-------------------------
-- SuperHero Variables --
-------------------------

function array_1d(m,n)
	local a, x = {}
	for x = 1, m do a[x] = n end
	return a
end

function array_2d(m,n,k)
	local a, x, y = {}
	for x = 0, m do a[x] = {}
		for y = 0, n do
			a[x][y] = k
		end
	end
	return a
end

function array_3d(m,n,l,k)
	local a, x, y, z = {}
	for x = 0, m do a[x] = {}
		for y = 0, n do a[x][y] = {}
			for z = 0, l do
				a[x][y][z] = k 
			end
		end
	end
	return a
end

sh = { round = { current = 1}, remove = {},config = {}, select = {}, update = {}, load = {}, add = {}, search = {}, set = {}, set2 = {}, member = { rank = {}, color = {}, name = {}}, error = {[[File Doesn't Exist]],[[File Is Corrupted]],[[Unknown Reason]]}, sucess = {[[Has Been Found!]]}, file = {[[superheroes.cfg]], [[items.cfg]], [[weaponrounds.cfg]], [[buildings.cfg]]}}
parses = {[[hudtxt]], [[hudtxt2]],[[setmaxhealth]],[[setarmor]],[[equip]],[[speedmod]], [[sethealth]], [[setmoney]], [[customkill]], [[explosion]], [[strip]], [[setweapon]], [[slap]], [[spawnobject]]}
cfg = { mark = {[[#addhero]], [[#additem]], [[#addround]], [[#addbuilding]]},error = {[[Not Enough Parameters]],[[Too Many Parameters]], [[Missing "=" Function Verification]], [[Wrong Parameters]], [[Building File Doesn't Exist!]]},
	h_func = { {[[#name]], 1, 1}, {[[#info]], 1, 1}, {[[#point]], 1, 0}, {[[#level]], 1, 0}, {[[#health]], 1, 0}, {[[#armor]], 1, 0}, {[[#item]], 1, 0}, {[[#speed]], 1, 0}, {[[#noreload]], 1, 0},{[[#spwn_info]], 1, 1}, {[[#sel_info]],1,1}, {[[#re_item]],2,0}, {[[#re_health]],2,0}, {[[#re_armor]],2,0}, {[[#re_money]],2,0}, {[[#kill_health]],1,0}, {[[#kill_armor]],1,0}, {[[#kill_money]],1,0}, {[[#e_kill_money]],1,0}, {[[#die_money]],1,0}, {[[#e_die_health]],1,0}, {[[#e_die_armor]],1,0}, {[[#e_die_money]],1,0},{[[#nb_health]],3,0}, {[[#nb_armor]],3,0}, {[[#nb_money]],3,0}, {[[#e_nb_damage]],3,0}, {[[#e_nb_money]],3,0}, {[[#e_nb_speed]],4,0}, {[[#nb_speed]],4,0}, {[[#die_explosion]],2,0},{[[#img_oval]],5,1}, {[[#damage1]],2,0}, {[[#damage2]],2,0}, {[[#hit_money]],1,0}, {[[#e_hit_money]],1,0}, {[[#e_hit_speed]],3,0}, {[[#kill_info]],1,1}, {[[#die_info]],1,1}, {[[#nb_info]],3,1}, {[[#throw_grenade]],8,1}, {[[#throw_weapon]],6,1},{[[#hook_spawn]],1,1}, {[[#hook_kill]],1,1}, {[[#hook_die]],1,1}, {[[#hook_second]],1,1}, {[[#hook_select]],1,1}, {[[#hook_reload]],1,1}, {[[#hook_attack]],1,1}, {[[#hook_hit]],1,1}, {[[#hook_build]],1,1}, {[[#sh_item]],1,0}},
	i_func = { {[[#name]], 1, 1}, {[[#info]], 1, 1}, {[[#level]], 1, 0}, {[[#credit]], 1, 0}, {[[#slot]], 1, 0}, {[[#health]], 1, 0}, {[[#armor]],1, 0}, {[[#item]], 1, 0}, {[[#speed]], 1, 0}, {[[#use_health]],1,0}, {[[#use_armor]],1,0}, {[[#use_speed]],2,0}, {[[#use_explosion]],2,0}, {[[#use_cancel]],1,1}, {[[#hero]],1,0}, {[[#use_build]],1,0}, {[[#hook_use]],1,1}, {[[#hook_spawn]],1,1}}}
hero = { level = {}, name = {}, info = {}, point = {}, upgrade = {}, health = {}, armor = {}, item = {}, speed = {}, noreload = {}, spwn_info = {}, sel_info = {}, re_item = {}, re_health = {}, re_armor = {}, re_money = {}, kill_health = {}, kill_armor = {}, kill_money = {}, e_kill_money = {}, die_money = {}, e_die_health = {}, e_die_armor = {}, e_die_money = {}, nb_health = {}, nb_armor= {}, nb_money = {}, e_nb_damage = {}, e_nb_money = {}, e_nb_speed = {}, nb_speed = {}, die_explosion = {}, img_oval = {}, damage1 = {}, damage2 = {}, hit_money = {}, e_hit_money = {}, e_hit_speed = {}, kill_info = {}, die_info = {}, nb_info = {}, throw_grenade = {}, throw_weapon = {},hook_spawn = {}, hook_kill = {}, hook_die = {}, hook_second = {}, hook_select = {}, hook_reload = {}, hook_attack = {}, hook_hit = {}, hook_build = {}, sh_item ={}}
sh_item = {name = {}, info = {}, level = {}, credit = {}, slot = {}, health = {}, armor = {}, item = {}, speed = {}, use_health = {}, use_armor = {}, use_speed = {}, use_explosion = {}, use_cancel = {}, hero = {}, use_build = {}, hook_use = {}, hook_spawn = {}}
building = {name = {}, c_x = {}, c_y = {}, pos = array_3d(sh_max_items,50, 50,0), x = {}, y = {}}
cfg.parse = {sh_xp_start, sh_pt_start, sh_credit_start, sh_lvl_ratio, sh_lvl_start}
pl = { menu_id = array_1d(32, 1), hero = array_2d(32,sh_max_heroes,nil), item = array_2d(32,sh_max_items,nil), stat = array_2d(32,5,0), join = array_1d(32, nil), help = array_1d(32, nil), re_item = array_2d(32,sh_max_heroes,0), re_health = array_2d(32,sh_max_heroes,0), re_armor = array_2d(32,sh_max_heroes,0), re_money = array_2d(32,sh_max_heroes,0), nb_health = array_2d(32,sh_max_heroes,0), nb_armor = array_2d(32,sh_max_heroes,0), nb_money = array_2d(32,sh_max_heroes,0), e_nb_damage = array_2d(32,sh_max_heroes,0), e_nb_money = array_2d(32,sh_max_heroes,0), e_nb_speed = array_2d(32,sh_max_heroes,0), speed = array_1d(32,0), t_speed = array_1d(32,0), nb_speed = array_2d(32,sh_max_heroes,0), img_oval = array_2d(32,sh_max_heroes,nil), nb_info = array_2d(32,sh_max_heroes,0), throw_grenade = array_2d(32,sh_max_heroes,nil), throw_weapon = array_2d(32,sh_max_heroes,nil)}
men = { title = {[[Select Super Power]],[[Remove Super Power]],[[Shop - Buy Items]], [[Inventory - Use Items]], [[Market - Sell Items]], [[Console Commands]], [[Say Commands]], [[Server Config]], [[SuperHero Menu]], [[Items Menu]]}}
sh.timer = {} ; sh.timer_cnt = 0
sh.say = {cmd = {},info = { help = {[[ - Main SuperHero Menu]], 1}, console = {[[ - List Of Console Commands]], 1},commands = {[[ - Say Commands List]], 1}, heroes = {[[ - Select Your Powers]], 1}, reheroes = {[[ - Remove Your Powers]], 1}, myheroes = {[[ - List Of Selected Heroes]], 1}, mystats = {[[ - Your Stats]],1}, heroeslist = {[[ - List Of Heroes]], 1}, playerslist = {[[ - List Of Players On Server]], 1}, whohas = {[[ <hero> - Shows Who Has Specified Hero]], 2}, clearheroes = {[[ - Remove All Your Heroes]], 1}, whatstats = {[[ <id > - Watch Other Player's Stats]], 2}, whatheroes = {[[ <id> - Watch Other Player's Heroes]], 2},helpon = {[[ - Show Help]],1},helpoff = {[[ - Hide Help]],1}, shop = {[[ - Buy Items]], 1}, members = {[[ - Server Members List]], 1}, roundlist = {[[ - List Of Weapon Rounds]], 1}, myitems = {[[ - Your Items List]], 1}, inventory = {[[ - Your Inventory]], 1}, givecr = {[[ <id> <cr> - Give Your Own Credits]], 3}, market = {[[ - Sell Items]],1}, register = {[[ <name> <password> - Create CSH User]], 3}, login = { [[ <name> <password> - Login With CSH User]],3}, logout = {[[ - Logout From CSH User]], 1}, reset = {[[ - Resets Your Stats]], 1}, kick = {[[ <id> - (Kick's Only For Members)]], 2}}}
sh.con = {cmd = {}, info = { help = {[[ - Main SuperHero Menu]],1},list_console = {[[ - Console Commands List]],1}, list_players = {[[ - Players List]], 1}, list_say = {[[ - Say Commands List]],1}, list_heroes = {[[ - Heroes List]], 1}, list_items = {[[ - Items List]], 1}, list_config = {[[ - Config Functions List]], 1},list_functions = {[[ - SuperHero Functions List]], 1}, list_lua = {[[ - Lua Table Class List]], 1}, give_xp = {[[ <id> <xp> - Give Experience For Player]], 3}, give_lvl = {[[ <id> <lvl> - Give Level For Player]], 3}, give_pt = {[[ <id> <pt> - Give Points For Player (temporary)]], 3}, give_credits = {[[ <id> <cr> - Give Credits For Player]], 3}, set_lvl = {[[ <id> <lvl> - Set Level For Player]],3}, set_xp = {[[ <id> <xp> - Set Experience For Player]], 3}, set_credits = {[[ <id> <cr> - Set Credits For Player]], 3}, give_all_credits = {[[ <cr> - Give Credits For All]], 2}, set_all_credits = {[[ <cr> - Set Credits For All]], 2}}}
sh.RGB = { black = {0,0,0}, red = {255,0,0}, green = {0,255,0}, blue = {64,64,255}, yellow = {255,255,0}, mageta = {255,0,255}, cyan = {0,255,255}, brown = {128,64,0}, purple = {128,0,255}, orange = {255, 128, 0}, gray = {128,128,128}, l_green = {128, 255, 128}}
user = { login = {}, name = {}, password = {}}
ut = { timer = array_1d(32,0), level = array_1d(32,0), blood = nil, kill = {[[Doublekill]],[[Multikill]],[[Ultrakill]],[[Monsterkill]],[[Killingspree]],[[Rampage]],[[Unstoppable]],[[Godlike]]}}
help = {line = {}} ; spc = [[     |     ]]
obj = { x = {}, y = {}, id = {}, rot = {}, rot2 = {}, speed = {},img = {}, dmg = {}, rad = {}, type = {}, idle = {}, wpn = {}}
badwords = {} ; round = {}
roundtype = {[1] = 1, [2] = 2, [10] = 1, [11] = 2, [12] = 1, [20] = 1, [21] = 2, [30] = 1, [31] = 2, [40] = 1, [41] = 2, [50] = 1, [51] = 2, [60] = 1, [61] = 2} 
color = {[[000255000]], [[255000000]],[[255200000]],[[096255096]],[[160160255]],[[255255000]], [[255128064]], [[255000255]]}
map_chars = {[" "] = 0,["B"] = 1,["b"] = 1,["M"] = 20,["m"] = 20,["S"] = 9,["s"] = 9,["W"] = 2,["w"] = 2,["0"] = 8,["1"] = 11,["2"] = 12,["3"] = 03,["4"] = 4,["5"] = 5,["#"] = 6,["$"] = 7,["["] = 13,["]"] = 14,["O"] = 22,["o"] = 22,["B"] = 23, ["b"] = 23}
p_id, v_id, k_id, hero_id, item_id, wpn_id, hp_dmg, ap_dmg, hero_lvl = 0, 0, 0, 0, 0, 0, 0, 0, 0, 0